; LEX5_ASM on WIN1_LIB
; 20th September 2015
;
; subroutine to EX or EW
;
; On entry:-
;
; A0 -> Prog name
; A1 -> The string for stack
;   (length of string|no of channels|channels|length of str|str)
;   For no channels or pars A1 = 0
; A2 -> Reg string	(A2=0 if no string)
;   Reg string is 12 long words for D0, D1. . up to A3
; D2.B = Priority
; D1.L = Job owner (-1, or 0)
; D3.W = 0 for EX, -1 for EW
;
; On exit:-
;
; A0 -> Header of JOB
; A1 corrupted
; A2 corrupted
;
; D0 is error code (if D3.W = 0): return from called job if D3.W = -1
; D1 is the called job's ID
; D2 is unchanged
; D3 is unchanged

; ERROR returns in D0 (TST'd)
;
	MOVEM.L	D1-D4/D6/A4-5,-(A7) 28 bytes
	MOVEQ	#0,D3		OPEN
	MOVEA.L	A1,A4		-> chans/pars or 0
	CMP.L	A1,D3		chans/pars? . .
	BNE	L1		. . yes
	LEA	NULL,A4		set no chans/pars
L1
	BSR	OPENFILE		possibly using PROGD$
	BNE	EREX3	   ---->
	MOVEQ	#64,D2		size of space for header
	MOVEQ	#-1,D3
	LEA	-64(A7),A7	keep space for header
	MOVEA.L	A7,A1		-> header space
	MOVEQ	#FS_HEADR,D0	get header . .
	TRAP	#3
	TST.L	D0
	BNE	EREX2	   ---->	. . oops
	MOVEA.L	A7,A1		reset pointer to header
	MOVEA.L	A0,A5		file ID to A5
	MOVE.B	5(A1),D0		type of file
	SUBQ.B	#1,D0		is it executable? . .
	BNE.S	EREX7	   ---->	. . no
	MOVE.L	(A1),D2		length of file
	MOVE.W	(A4)+,D6		length of chans/pars string . .
	ADDQ.W	#1,D6
	BCLR	#0,D6		. . rounded up
	MOVE.W	D6,D3		Add this . .
	EXT.L	D3
	ADD.L	6(A1),D3		. . to dataspace
	LEA	64(A7),A7 	throw away header space
	MOVE.L	(A7)+,D1		retrieve owner job
	SUBA.L	A1,A1		no start address
	MOVEQ	#MT_CJOB,D0	create . .
	TRAP	#1		. . the job . .
	TST.L	D0
	BNE.S	EREX8	   ---->	. . oops
	MOVEA.L	A0,A1		Job address in A1 . .
	EXG	A0,A5		. . and A5. A0 = file ID
	MOVE.L	D1,D4		keep new job ID in D4
	MOVEQ	#-1,D3
	MOVEQ	#FS_LOAD,D0	load code . .
	TRAP	#3
	TST.L	D0
	BNE.S	EREX4	   ---->	. . oops
	MOVEQ	#IO_CLOSE,D0	close the . .
	TRAP	#2		. . file's channels . .
	TST.L	D0
	BNE	EREX6	   ---->	. . oops
	CMPA.W	#0,A2		Reg string? . .
	BEQ	L4		. . no
	MOVEQ	#11,D0
	LEA	JB_D0-$68(A5),A0
L3	MOVE.L	(A2)+,(A0)+
	DBF	D0,L3
L4	MOVEA.L	JB_A7-$68(A5),A0	new job's stack
	ADDQ.L	#4,A0		set to the end of data space
	LEA	(A4,D6.W),A4	set to the end of the string
	LSR.W	#1,D6		no of words . .
	SUBQ.W	#1,D6		. . less 1
	BMI	EREX9	 ---->	no string!
L2	MOVE.W	-(A4),-(A0)	put chans/pars to stack
	DBF	D6,L2
	MOVE.L	A0,JB_A7-$68(A5)	store new value of stack
	MOVE.L	D4,D1		retrieve new job's ID
	MOVEM.L	(A7)+,D2-D4/D6/A4-5
	MOVEQ	#MT_ACTIV,D0	activate it
	TRAP	#1
	TST.L	D0
EREX	RTS
;
EREX7	MOVEQ	#-1,D0
EREX2	LEA	64(A7),A7
EREX5	ADDQ.L	#4,A7
EREX4	LEA	24(A7),A7
	MOVE.L	D0,D4		keep ERROR code
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVE.L	D4,D0
	BRA.S	EREX1
;
EREX3	ADDQ.L	#4,A7
EREX6	LEA	24(A7),A7
EREX1	MOVEQ	#0,D1
	BRA.S	EREX
;
EREX8	MOVEA.L	A5,A0		replace ID
	BRA	EREX4

EREX9	MOVEQ	#-1,D0
	BRA	EREX6

NULL	DC.W	2,0,0		No chans or par list

;       The following routines were added by Dave Walker to GWASS

;======================================================================
;		    STRING HANDLING
;
;   Useful string handling routines.
;
;   - These are based on C68 C style routines adapted to handle QL strings.
;   - Parameters are passed on the stack.
;   - All registers are preserved.
;   - The calling routines must tidy the stack.
;----------------------------------------------------------------------

;   Copy a QL string
;	4(A7) = Target
;	8(A7) = Source

QSTRCPY
	MOVEM.L	D0/A0-A1,-(A7)	; save regosters used
	MOVE.L	12+4(A7),A1	; Target address
	MOVE.L	12+8(A7),A0	; Source address
	MOVE.W	(A0),D0		; Length to copy
	MOVE.W	(A0)+,(A1)+	; Copy length field
	BRA	QSTRCPY2		; Remove if NULL byte at end wanted
QSTRCPY1	MOVE.B	(A0)+,(A1)+	; Copy a byte
QSTRCPY2	DBRA	D0,QSTRCPY1	; loop until finished
	MOVEM.L	(A7)+,D0/A0-A1	; restore saved registers
	RTS

;   Concatenate a QL string onto another one
;	4(A7) = Target
;	8(A7) = Source

QSTRCAT
	MOVEM.L	D0/A0-A1,-(A7)
	MOVE.L	12+4(A7),A1	; Target address
	MOVE.L	12+8(A7),A0	; Source address
	MOVE.W	(A1),D0		; get old length
	ADD.W	(A0),D0		; Calculate new length
	MOVE.W	D0,(A1)+		; Store new length
	SUB.W	(A0),D0		; Reset to old length
	ADDA.W	D0,A1		; skip over current data
	MOVE.W	(A0)+,D0		; get length to copy
	BRA	QSTRCPY2


;   Copy a QL string with maximum length check
;	4(A7).L  = Target
;	8(A7).L  = Source
;	12(A7).W = Maximum length

QSTRNCPY
	MOVEM.L	D0-D1/A0-A2,-(A7)
	MOVE.L	20+4(A7),A1	; Target address
	MOVE.L	A1,A2		; ... copied to A2
	MOVE.L	20+8(A7),A0	; Source address
	MOVE.W	20+12(A7),D1	; Maximum length
	MOVE.W	(A0)+,D0		; Length to copy
	CLR.W	(A1)+		; Clear target length
	BRA	QSTRNCPY2
QSTRNCPY1 CMP.W	(A2),D1		; Check max length not reached
	BEQ	QSTRNCPY3 	; If so exit immediately
	ADDQ.W	#1,(A2)		; Update length
	MOVE.B	(A0)+,(A1)+	; ... and copy byte
QSTRNCPY2 DBRA	D0,QSTRNCPY1	; Loop until finished
QSTRNCPY3 MOVEM.L	(A7)+,D0-D1/A0-A2
	RTS

;   Concatenate a QL string onto another one with maximum length check
;	4(A7) = Target
;	8(A7) = Source

QSTRNCAT
	MOVEM.L	D0-D1/A0-A2,-(A7)
	MOVE.L	20+4(A7),A1	; Target address
	MOVE.L	A1,A2		; copied to A2
	MOVE.L	20+8(A7),A0	; Source address
	MOVE.W	20+12(A7),D1	; Maximum length
	MOVE.W	(A1)+,D0		; Existing length
	ADDA.W	D0,A1		; Skip over source length
	MOVE.W	(A0)+,D0		; Length to copy
	BRA	QSTRNCPY2 	; Join QSTRNCPY code

;======================================================================
;		       FILE HANDLING
;
;   Friendly versions of file open/delete that will
;   allow use of TK2 directories in names.
;
;   These routines assume that the parameters have been set up
;   for the respective TRAP #2 call.  They can then be called
;   in place of the TRAP #2 routine.
;-----------------------------------------------------------------------

;   When we OPEN a file we want to try the open in
;   the following sequence of events:
;     - The name exactly as supplied
;     - If that fails, the name with the PROG_USE directory
;	added to the front.

	RSSET	-2*58
TK2_BUFF	RS.B	58
PROGD	RS.B	58

OPENFILE	LINK	A6,#-2*58 	 ; get working space
	BSR	SET_DP		; set PROGD
	MOVEQ	#IO_OPEN,D0
	MOVEQ	#-1,D1
	MOVEM.L	D0/A0,-(A7)	; Save name pointer

;	We start by trying the name exactly as passed

	TRAP	#2		; Try operation
	TST.L	D0		; OK?
	BEQ	OPENEXIT		; YES, jump

;	If we failed with the first try, we now want
;	to try with the PROG_USE directory added


	MOVEM.L	(A7),D0/A0	; restore saved registers
	BSR	PROG_USE
	TRAP	#2

OPENEXIT	ADDA.W	#2*4,A7		; remove saved values
	TST.L	D0		; set condition code
	UNLK	A6		; throw away working space
	RTS

;	Get the PROG_USE value, and build up a name
;	which has this at the front followed by the
;	users name and try that.

PROG_USE	PEA	PROGD(A6)
	PEA	TK2_BUFF(A6)	; Target
	BSR	QSTRCPY
	ADDQ.L	#8,A7		; Remove parameters
	MOVE.W	#50,-(A7) 	; Max length
	MOVE.L	A0,-(A7)		; Source
	PEA	TK2_BUFF(A6)	; Target
	BSR	QSTRNCAT
	ADDA.W	#10,A7		; Remove parameters
	LEA	TK2_BUFF(A6),A0	; set A0 to new filename
	RTS

;
; No registers are used
;
SET_DP	MOVEM.L	D0-2/D4/A0-1,-(A7)
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVE.L	SV_PROG(A0),-(A7)
	BEQ	SET_DP4		no PROGD$
	PEA	PROGD(A6)
	BSR	QSTRCPY
	ADDQ.L	#8,A7
	BRA	SET_DP5
SET_DP4	ADDQ.L	#4,A7
SET_DP3	CLR.W	PROGD(A6)
SET_DP5	MOVEM.L	(A7)+,D0-2/D4/A0-1
	RTS


;
	END
